<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestHttpRoute xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/conn/routing/TestHttpRoute.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.conn.routing;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.net.InetAddress;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.util.HashSet;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.Set;
<a class="jxr_linenumber" name="34" href="#34">34</a>  
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.TunnelType;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.LayerType;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="40" href="#40">40</a>  
<a class="jxr_linenumber" name="41" href="#41">41</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="42" href="#42">42</a>  <em class="jxr_javadoccomment"> * Tests for {@link HttpRoute}.</em>
<a class="jxr_linenumber" name="43" href="#43">43</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/conn/routing/TestHttpRoute.html">TestHttpRoute</a> {
<a class="jxr_linenumber" name="45" href="#45">45</a>  
<a class="jxr_linenumber" name="46" href="#46">46</a>      <em class="jxr_comment">// a selection of constants for generating routes</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="48" href="#48">48</a>          HttpHost TARGET1 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"target1.test.invalid"</span>);
<a class="jxr_linenumber" name="49" href="#49">49</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="50" href="#50">50</a>          HttpHost TARGET2 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"target2.test.invalid"</span>, 8080);
<a class="jxr_linenumber" name="51" href="#51">51</a>      <em class="jxr_comment">// It is not necessary to have extra targets for https.</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>      <em class="jxr_comment">// The 'layered' and 'secure' flags are specified explicitly</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>      <em class="jxr_comment">// for routes, they will not be determined from the scheme.</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  
<a class="jxr_linenumber" name="55" href="#55">55</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="56" href="#56">56</a>          HttpHost PROXY1 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy1.test.invalid"</span>);
<a class="jxr_linenumber" name="57" href="#57">57</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="58" href="#58">58</a>          HttpHost PROXY2 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy2.test.invalid"</span>, 1080);
<a class="jxr_linenumber" name="59" href="#59">59</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong>
<a class="jxr_linenumber" name="60" href="#60">60</a>          HttpHost PROXY3 = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"proxy3.test.invalid"</span>, 88);
<a class="jxr_linenumber" name="61" href="#61">61</a>  
<a class="jxr_linenumber" name="62" href="#62">62</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL41;
<a class="jxr_linenumber" name="63" href="#63">63</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL42;
<a class="jxr_linenumber" name="64" href="#64">64</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL61;
<a class="jxr_linenumber" name="65" href="#65">65</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> InetAddress LOCAL62;
<a class="jxr_linenumber" name="66" href="#66">66</a>  
<a class="jxr_linenumber" name="67" href="#67">67</a>      <em class="jxr_comment">// need static initializer to deal with exceptions</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>      <strong class="jxr_keyword">static</strong> {
<a class="jxr_linenumber" name="69" href="#69">69</a>          <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="70" href="#70">70</a>              LOCAL41 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{ 127, 0, 0, 1 });
<a class="jxr_linenumber" name="71" href="#71">71</a>              LOCAL42 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{ 127, 0, 0, 2 });
<a class="jxr_linenumber" name="72" href="#72">72</a>  
<a class="jxr_linenumber" name="73" href="#73">73</a>              LOCAL61 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{
<a class="jxr_linenumber" name="74" href="#74">74</a>                  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
<a class="jxr_linenumber" name="75" href="#75">75</a>              });
<a class="jxr_linenumber" name="76" href="#76">76</a>              LOCAL62 = InetAddress.getByAddress(<strong class="jxr_keyword">new</strong> byte[]{
<a class="jxr_linenumber" name="77" href="#77">77</a>                  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2
<a class="jxr_linenumber" name="78" href="#78">78</a>              });
<a class="jxr_linenumber" name="79" href="#79">79</a>  
<a class="jxr_linenumber" name="80" href="#80">80</a>          } <strong class="jxr_keyword">catch</strong> (Exception x) {
<a class="jxr_linenumber" name="81" href="#81">81</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> ExceptionInInitializerError(x);
<a class="jxr_linenumber" name="82" href="#82">82</a>          }
<a class="jxr_linenumber" name="83" href="#83">83</a>      }
<a class="jxr_linenumber" name="84" href="#84">84</a>  
<a class="jxr_linenumber" name="85" href="#85">85</a>      @Test
<a class="jxr_linenumber" name="86" href="#86">86</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstrFullRoute() {
<a class="jxr_linenumber" name="87" href="#87">87</a>          <em class="jxr_comment">// create a route with all arguments and check the details</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>          HttpHost[] chain3 = { PROXY1, PROXY2, PROXY3 };
<a class="jxr_linenumber" name="89" href="#89">89</a>  
<a class="jxr_linenumber" name="90" href="#90">90</a>          HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="91" href="#91">91</a>                                          TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="92" href="#92">92</a>          Assert.assertEquals(<span class="jxr_string">"wrong target"</span>,
<a class="jxr_linenumber" name="93" href="#93">93</a>                       TARGET1, route.getTargetHost());
<a class="jxr_linenumber" name="94" href="#94">94</a>          Assert.assertEquals(<span class="jxr_string">"wrong local address"</span>,
<a class="jxr_linenumber" name="95" href="#95">95</a>                       LOCAL41, route.getLocalAddress());
<a class="jxr_linenumber" name="96" href="#96">96</a>          Assert.assertEquals(<span class="jxr_string">"wrong proxy host"</span>,
<a class="jxr_linenumber" name="97" href="#97">97</a>                       PROXY1, route.getProxyHost());
<a class="jxr_linenumber" name="98" href="#98">98</a>          Assert.assertEquals(<span class="jxr_string">"wrong hop count"</span>,
<a class="jxr_linenumber" name="99" href="#99">99</a>                       4, route.getHopCount());
<a class="jxr_linenumber" name="100" href="#100">100</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop 0"</span>,
<a class="jxr_linenumber" name="101" href="#101">101</a>                      PROXY1, route.getHopTarget(0));
<a class="jxr_linenumber" name="102" href="#102">102</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop 1"</span>,
<a class="jxr_linenumber" name="103" href="#103">103</a>                      PROXY2, route.getHopTarget(1));
<a class="jxr_linenumber" name="104" href="#104">104</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop 2"</span>,
<a class="jxr_linenumber" name="105" href="#105">105</a>                      PROXY3, route.getHopTarget(2));
<a class="jxr_linenumber" name="106" href="#106">106</a>         Assert.assertEquals(<span class="jxr_string">"wrong hop 3"</span>,
<a class="jxr_linenumber" name="107" href="#107">107</a>                      TARGET1, route.getHopTarget(3));
<a class="jxr_linenumber" name="108" href="#108">108</a>         Assert.assertFalse(<span class="jxr_string">"wrong flag: secured"</span>, route.isSecure());
<a class="jxr_linenumber" name="109" href="#109">109</a>         Assert.assertFalse(<span class="jxr_string">"wrong flag: tunnelled"</span>, route.isTunnelled());
<a class="jxr_linenumber" name="110" href="#110">110</a>         Assert.assertFalse(<span class="jxr_string">"wrong flag: layered"</span>, route.isLayered());
<a class="jxr_linenumber" name="111" href="#111">111</a> 
<a class="jxr_linenumber" name="112" href="#112">112</a>         String routestr = route.toString();
<a class="jxr_linenumber" name="113" href="#113">113</a>         Assert.assertTrue(<span class="jxr_string">"missing target in toString"</span>,
<a class="jxr_linenumber" name="114" href="#114">114</a>                    routestr.indexOf(TARGET1.getHostName()) &gt;= 0);
<a class="jxr_linenumber" name="115" href="#115">115</a>         Assert.assertTrue(<span class="jxr_string">"missing local address in toString"</span>,
<a class="jxr_linenumber" name="116" href="#116">116</a>                    routestr.indexOf(LOCAL41.toString()) &gt;= 0);
<a class="jxr_linenumber" name="117" href="#117">117</a>         Assert.assertTrue(<span class="jxr_string">"missing proxy 1 in toString"</span>,
<a class="jxr_linenumber" name="118" href="#118">118</a>                    routestr.indexOf(PROXY1.getHostName()) &gt;= 0);
<a class="jxr_linenumber" name="119" href="#119">119</a>         Assert.assertTrue(<span class="jxr_string">"missing proxy 2 in toString"</span>,
<a class="jxr_linenumber" name="120" href="#120">120</a>                    routestr.indexOf(PROXY2.getHostName()) &gt;= 0);
<a class="jxr_linenumber" name="121" href="#121">121</a>         Assert.assertTrue(<span class="jxr_string">"missing proxy 3 in toString"</span>,
<a class="jxr_linenumber" name="122" href="#122">122</a>                    routestr.indexOf(PROXY3.getHostName()) &gt;= 0);
<a class="jxr_linenumber" name="123" href="#123">123</a>     }
<a class="jxr_linenumber" name="124" href="#124">124</a> 
<a class="jxr_linenumber" name="125" href="#125">125</a>     @Test
<a class="jxr_linenumber" name="126" href="#126">126</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstrFullFlags() {
<a class="jxr_linenumber" name="127" href="#127">127</a>         <em class="jxr_comment">// tests the flag parameters in the full-blown constructor</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> 
<a class="jxr_linenumber" name="129" href="#129">129</a>         HttpHost[] chain3 = { PROXY1, PROXY2, PROXY3 };
<a class="jxr_linenumber" name="130" href="#130">130</a> 
<a class="jxr_linenumber" name="131" href="#131">131</a>         HttpRoute routefff = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="132" href="#132">132</a>             (TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="133" href="#133">133</a>              TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="134" href="#134">134</a>         HttpRoute routefft = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="135" href="#135">135</a>             (TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="136" href="#136">136</a>              TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="137" href="#137">137</a>         HttpRoute routeftf = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="138" href="#138">138</a>             (TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="139" href="#139">139</a>              TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="140" href="#140">140</a>         HttpRoute routeftt = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="141" href="#141">141</a>             (TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="142" href="#142">142</a>              TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="143" href="#143">143</a>         HttpRoute routetff = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="144" href="#144">144</a>             (TARGET1, LOCAL41, chain3, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="145" href="#145">145</a>              TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="146" href="#146">146</a>         HttpRoute routetft = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="147" href="#147">147</a>             (TARGET1, LOCAL41, chain3, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="148" href="#148">148</a>              TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="149" href="#149">149</a>         HttpRoute routettf = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="150" href="#150">150</a>             (TARGET1, LOCAL41, chain3, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="151" href="#151">151</a>              TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="152" href="#152">152</a>         HttpRoute routettt = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="153" href="#153">153</a>             (TARGET1, LOCAL41, chain3, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="154" href="#154">154</a>              TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="155" href="#155">155</a> 
<a class="jxr_linenumber" name="156" href="#156">156</a>         Assert.assertFalse(<span class="jxr_string">"routefff.secure"</span>, routefff.isSecure());
<a class="jxr_linenumber" name="157" href="#157">157</a>         Assert.assertFalse(<span class="jxr_string">"routefff.tunnel"</span>, routefff.isTunnelled());
<a class="jxr_linenumber" name="158" href="#158">158</a>         Assert.assertFalse(<span class="jxr_string">"routefff.layer"</span> , routefff.isLayered());
<a class="jxr_linenumber" name="159" href="#159">159</a> 
<a class="jxr_linenumber" name="160" href="#160">160</a>         Assert.assertFalse(<span class="jxr_string">"routefft.secure"</span>, routefft.isSecure());
<a class="jxr_linenumber" name="161" href="#161">161</a>         Assert.assertFalse(<span class="jxr_string">"routefft.tunnel"</span>, routefft.isTunnelled());
<a class="jxr_linenumber" name="162" href="#162">162</a>         Assert.assertTrue (<span class="jxr_string">"routefft.layer"</span> , routefft.isLayered());
<a class="jxr_linenumber" name="163" href="#163">163</a> 
<a class="jxr_linenumber" name="164" href="#164">164</a>         Assert.assertFalse(<span class="jxr_string">"routeftf.secure"</span>, routeftf.isSecure());
<a class="jxr_linenumber" name="165" href="#165">165</a>         Assert.assertTrue (<span class="jxr_string">"routeftf.tunnel"</span>, routeftf.isTunnelled());
<a class="jxr_linenumber" name="166" href="#166">166</a>         Assert.assertFalse(<span class="jxr_string">"routeftf.layer"</span> , routeftf.isLayered());
<a class="jxr_linenumber" name="167" href="#167">167</a> 
<a class="jxr_linenumber" name="168" href="#168">168</a>         Assert.assertFalse(<span class="jxr_string">"routeftt.secure"</span>, routeftt.isSecure());
<a class="jxr_linenumber" name="169" href="#169">169</a>         Assert.assertTrue (<span class="jxr_string">"routeftt.tunnel"</span>, routeftt.isTunnelled());
<a class="jxr_linenumber" name="170" href="#170">170</a>         Assert.assertTrue (<span class="jxr_string">"routeftt.layer"</span> , routeftt.isLayered());
<a class="jxr_linenumber" name="171" href="#171">171</a> 
<a class="jxr_linenumber" name="172" href="#172">172</a>         Assert.assertTrue (<span class="jxr_string">"routetff.secure"</span>, routetff.isSecure());
<a class="jxr_linenumber" name="173" href="#173">173</a>         Assert.assertFalse(<span class="jxr_string">"routetff.tunnel"</span>, routetff.isTunnelled());
<a class="jxr_linenumber" name="174" href="#174">174</a>         Assert.assertFalse(<span class="jxr_string">"routetff.layer"</span> , routetff.isLayered());
<a class="jxr_linenumber" name="175" href="#175">175</a> 
<a class="jxr_linenumber" name="176" href="#176">176</a>         Assert.assertTrue (<span class="jxr_string">"routetft.secure"</span>, routetft.isSecure());
<a class="jxr_linenumber" name="177" href="#177">177</a>         Assert.assertFalse(<span class="jxr_string">"routetft.tunnel"</span>, routetft.isTunnelled());
<a class="jxr_linenumber" name="178" href="#178">178</a>         Assert.assertTrue (<span class="jxr_string">"routetft.layer"</span> , routetft.isLayered());
<a class="jxr_linenumber" name="179" href="#179">179</a> 
<a class="jxr_linenumber" name="180" href="#180">180</a>         Assert.assertTrue (<span class="jxr_string">"routettf.secure"</span>, routettf.isSecure());
<a class="jxr_linenumber" name="181" href="#181">181</a>         Assert.assertTrue (<span class="jxr_string">"routettf.tunnel"</span>, routettf.isTunnelled());
<a class="jxr_linenumber" name="182" href="#182">182</a>         Assert.assertFalse(<span class="jxr_string">"routettf.layer"</span> , routettf.isLayered());
<a class="jxr_linenumber" name="183" href="#183">183</a> 
<a class="jxr_linenumber" name="184" href="#184">184</a>         Assert.assertTrue (<span class="jxr_string">"routettt.secure"</span>, routettt.isSecure());
<a class="jxr_linenumber" name="185" href="#185">185</a>         Assert.assertTrue (<span class="jxr_string">"routettt.tunnel"</span>, routettt.isTunnelled());
<a class="jxr_linenumber" name="186" href="#186">186</a>         Assert.assertTrue (<span class="jxr_string">"routettt.layer"</span> , routettt.isLayered());
<a class="jxr_linenumber" name="187" href="#187">187</a> 
<a class="jxr_linenumber" name="188" href="#188">188</a> 
<a class="jxr_linenumber" name="189" href="#189">189</a>         Set&lt;HttpRoute&gt; routes = <strong class="jxr_keyword">new</strong> HashSet&lt;HttpRoute&gt;();
<a class="jxr_linenumber" name="190" href="#190">190</a>         routes.add(routefff);
<a class="jxr_linenumber" name="191" href="#191">191</a>         routes.add(routefft);
<a class="jxr_linenumber" name="192" href="#192">192</a>         routes.add(routeftf);
<a class="jxr_linenumber" name="193" href="#193">193</a>         routes.add(routeftt);
<a class="jxr_linenumber" name="194" href="#194">194</a>         routes.add(routetff);
<a class="jxr_linenumber" name="195" href="#195">195</a>         routes.add(routetft);
<a class="jxr_linenumber" name="196" href="#196">196</a>         routes.add(routettf);
<a class="jxr_linenumber" name="197" href="#197">197</a>         routes.add(routettt);
<a class="jxr_linenumber" name="198" href="#198">198</a>         Assert.assertEquals(<span class="jxr_string">"some flagged routes are equal"</span>, 8, routes.size());
<a class="jxr_linenumber" name="199" href="#199">199</a> 
<a class="jxr_linenumber" name="200" href="#200">200</a>         <em class="jxr_comment">// we can't test hashCode in general due to its dependency</em>
<a class="jxr_linenumber" name="201" href="#201">201</a>         <em class="jxr_comment">// on InetAddress and HttpHost, but we can check for the flags</em>
<a class="jxr_linenumber" name="202" href="#202">202</a>         Set&lt;Integer&gt; routecodes = <strong class="jxr_keyword">new</strong> HashSet&lt;Integer&gt;();
<a class="jxr_linenumber" name="203" href="#203">203</a>         routecodes.add(Integer.valueOf(routefff.hashCode()));
<a class="jxr_linenumber" name="204" href="#204">204</a>         routecodes.add(Integer.valueOf(routefft.hashCode()));
<a class="jxr_linenumber" name="205" href="#205">205</a>         routecodes.add(Integer.valueOf(routeftf.hashCode()));
<a class="jxr_linenumber" name="206" href="#206">206</a>         routecodes.add(Integer.valueOf(routeftt.hashCode()));
<a class="jxr_linenumber" name="207" href="#207">207</a>         routecodes.add(Integer.valueOf(routetff.hashCode()));
<a class="jxr_linenumber" name="208" href="#208">208</a>         routecodes.add(Integer.valueOf(routetft.hashCode()));
<a class="jxr_linenumber" name="209" href="#209">209</a>         routecodes.add(Integer.valueOf(routettf.hashCode()));
<a class="jxr_linenumber" name="210" href="#210">210</a>         routecodes.add(Integer.valueOf(routettt.hashCode()));
<a class="jxr_linenumber" name="211" href="#211">211</a>         Assert.assertEquals(<span class="jxr_string">"some flagged routes have same hashCode"</span>,
<a class="jxr_linenumber" name="212" href="#212">212</a>                      8, routecodes.size());
<a class="jxr_linenumber" name="213" href="#213">213</a> 
<a class="jxr_linenumber" name="214" href="#214">214</a>         Set&lt;String&gt; routestrings = <strong class="jxr_keyword">new</strong> HashSet&lt;String&gt;();
<a class="jxr_linenumber" name="215" href="#215">215</a>         routestrings.add(routefff.toString());
<a class="jxr_linenumber" name="216" href="#216">216</a>         routestrings.add(routefft.toString());
<a class="jxr_linenumber" name="217" href="#217">217</a>         routestrings.add(routeftf.toString());
<a class="jxr_linenumber" name="218" href="#218">218</a>         routestrings.add(routeftt.toString());
<a class="jxr_linenumber" name="219" href="#219">219</a>         routestrings.add(routetff.toString());
<a class="jxr_linenumber" name="220" href="#220">220</a>         routestrings.add(routetft.toString());
<a class="jxr_linenumber" name="221" href="#221">221</a>         routestrings.add(routettf.toString());
<a class="jxr_linenumber" name="222" href="#222">222</a>         routestrings.add(routettt.toString());
<a class="jxr_linenumber" name="223" href="#223">223</a>         Assert.assertEquals(<span class="jxr_string">"some flagged route.toString() are equal"</span>,
<a class="jxr_linenumber" name="224" href="#224">224</a>                      8, routestrings.size());
<a class="jxr_linenumber" name="225" href="#225">225</a>     }
<a class="jxr_linenumber" name="226" href="#226">226</a> 
<a class="jxr_linenumber" name="227" href="#227">227</a>     @Test
<a class="jxr_linenumber" name="228" href="#228">228</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testInvalidArguments() {
<a class="jxr_linenumber" name="229" href="#229">229</a>         HttpHost[] chain0 = { <strong class="jxr_keyword">null</strong> };
<a class="jxr_linenumber" name="230" href="#230">230</a>         HttpHost[] chain1 = { PROXY1 };
<a class="jxr_linenumber" name="231" href="#231">231</a>         HttpHost[] chain4 = { PROXY1, PROXY2, <strong class="jxr_keyword">null</strong>, PROXY3 };
<a class="jxr_linenumber" name="232" href="#232">232</a> 
<a class="jxr_linenumber" name="233" href="#233">233</a>         <em class="jxr_comment">// for reference: this one should succeed</em>
<a class="jxr_linenumber" name="234" href="#234">234</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, chain1, false,
<a class="jxr_linenumber" name="235" href="#235">235</a>                                         TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="236" href="#236">236</a>         Assert.assertNotNull(route);
<a class="jxr_linenumber" name="237" href="#237">237</a> 
<a class="jxr_linenumber" name="238" href="#238">238</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="239" href="#239">239</a>             route = <strong class="jxr_keyword">new</strong> HttpRoute(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, chain1, false,
<a class="jxr_linenumber" name="240" href="#240">240</a>                                   TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="241" href="#241">241</a>             Assert.fail(<span class="jxr_string">"missing target not detected"</span>);
<a class="jxr_linenumber" name="242" href="#242">242</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="243" href="#243">243</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="244" href="#244">244</a>         }
<a class="jxr_linenumber" name="245" href="#245">245</a> 
<a class="jxr_linenumber" name="246" href="#246">246</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="247" href="#247">247</a>             route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, (HttpHost[]) <strong class="jxr_keyword">null</strong>, false,
<a class="jxr_linenumber" name="248" href="#248">248</a>                                   TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="249" href="#249">249</a>             Assert.fail(<span class="jxr_string">"missing proxy for tunnel not detected"</span>);
<a class="jxr_linenumber" name="250" href="#250">250</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="251" href="#251">251</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="252" href="#252">252</a>         }
<a class="jxr_linenumber" name="253" href="#253">253</a> 
<a class="jxr_linenumber" name="254" href="#254">254</a>         <em class="jxr_comment">// for the next two, we don't indicate a tunnel anymore</em>
<a class="jxr_linenumber" name="255" href="#255">255</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="256" href="#256">256</a>             <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, chain0, false,
<a class="jxr_linenumber" name="257" href="#257">257</a>                                   TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="258" href="#258">258</a>             Assert.fail(<span class="jxr_string">"invalid proxy chain (0) not detected"</span>);
<a class="jxr_linenumber" name="259" href="#259">259</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="260" href="#260">260</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="261" href="#261">261</a>         }
<a class="jxr_linenumber" name="262" href="#262">262</a> 
<a class="jxr_linenumber" name="263" href="#263">263</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="264" href="#264">264</a>             <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, chain4, false,
<a class="jxr_linenumber" name="265" href="#265">265</a>                                   TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="266" href="#266">266</a>             Assert.fail(<span class="jxr_string">"invalid proxy chain (4) not detected"</span>);
<a class="jxr_linenumber" name="267" href="#267">267</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="268" href="#268">268</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="269" href="#269">269</a>         }
<a class="jxr_linenumber" name="270" href="#270">270</a>     }
<a class="jxr_linenumber" name="271" href="#271">271</a> 
<a class="jxr_linenumber" name="272" href="#272">272</a>     @Test
<a class="jxr_linenumber" name="273" href="#273">273</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNullEnums() {
<a class="jxr_linenumber" name="274" href="#274">274</a> 
<a class="jxr_linenumber" name="275" href="#275">275</a>         <em class="jxr_comment">// tests the default values for the enum parameters</em>
<a class="jxr_linenumber" name="276" href="#276">276</a>         <em class="jxr_comment">// also covers the accessors for the enum attributes</em>
<a class="jxr_linenumber" name="277" href="#277">277</a> 
<a class="jxr_linenumber" name="278" href="#278">278</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, PROXY1, false,
<a class="jxr_linenumber" name="279" href="#279">279</a>                                         <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>); <em class="jxr_comment">// here are defaults</em>
<a class="jxr_linenumber" name="280" href="#280">280</a> 
<a class="jxr_linenumber" name="281" href="#281">281</a>         Assert.assertFalse(<span class="jxr_string">"default tunnelling"</span>, route.isTunnelled());
<a class="jxr_linenumber" name="282" href="#282">282</a>         Assert.assertEquals(<span class="jxr_string">"untunnelled"</span>, TunnelType.PLAIN, route.getTunnelType());
<a class="jxr_linenumber" name="283" href="#283">283</a> 
<a class="jxr_linenumber" name="284" href="#284">284</a>         Assert.assertFalse(<span class="jxr_string">"default layering"</span>, route.isLayered());
<a class="jxr_linenumber" name="285" href="#285">285</a>         Assert.assertEquals(<span class="jxr_string">"unlayered"</span>, LayerType.PLAIN, route.getLayerType());
<a class="jxr_linenumber" name="286" href="#286">286</a>     }
<a class="jxr_linenumber" name="287" href="#287">287</a> 
<a class="jxr_linenumber" name="288" href="#288">288</a>     @Test
<a class="jxr_linenumber" name="289" href="#289">289</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testEqualsHashcodeClone() <strong class="jxr_keyword">throws</strong> CloneNotSupportedException {
<a class="jxr_linenumber" name="290" href="#290">290</a>         HttpHost[] chain0 = { };
<a class="jxr_linenumber" name="291" href="#291">291</a>         HttpHost[] chain1 = { PROXY1 };
<a class="jxr_linenumber" name="292" href="#292">292</a>         HttpHost[] chain3 = { PROXY1, PROXY2, PROXY3 };
<a class="jxr_linenumber" name="293" href="#293">293</a>         HttpHost[] chain4 = { PROXY1, PROXY3, PROXY2 };
<a class="jxr_linenumber" name="294" href="#294">294</a> 
<a class="jxr_linenumber" name="295" href="#295">295</a>         <em class="jxr_comment">// create some identical routes</em>
<a class="jxr_linenumber" name="296" href="#296">296</a>         HttpRoute route1a = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="297" href="#297">297</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="298" href="#298">298</a>         HttpRoute route1b = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="299" href="#299">299</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="300" href="#300">300</a>         HttpRoute route1c = (HttpRoute) route1a.clone();
<a class="jxr_linenumber" name="301" href="#301">301</a> 
<a class="jxr_linenumber" name="302" href="#302">302</a>         Assert.assertEquals(<span class="jxr_string">"1a 1a"</span>, route1a, route1a);
<a class="jxr_linenumber" name="303" href="#303">303</a>         Assert.assertEquals(<span class="jxr_string">"1a 1b"</span>, route1a, route1b);
<a class="jxr_linenumber" name="304" href="#304">304</a>         Assert.assertEquals(<span class="jxr_string">"1a 1c"</span>, route1a, route1c);
<a class="jxr_linenumber" name="305" href="#305">305</a> 
<a class="jxr_linenumber" name="306" href="#306">306</a>         Assert.assertEquals(<span class="jxr_string">"hashcode 1a"</span>, route1a.hashCode(), route1a.hashCode());
<a class="jxr_linenumber" name="307" href="#307">307</a>         Assert.assertEquals(<span class="jxr_string">"hashcode 1b"</span>, route1a.hashCode(), route1b.hashCode());
<a class="jxr_linenumber" name="308" href="#308">308</a>         Assert.assertEquals(<span class="jxr_string">"hashcode 1c"</span>, route1a.hashCode(), route1c.hashCode());
<a class="jxr_linenumber" name="309" href="#309">309</a> 
<a class="jxr_linenumber" name="310" href="#310">310</a>         Assert.assertEquals(<span class="jxr_string">"toString 1a"</span>, route1a.toString(), route1a.toString());
<a class="jxr_linenumber" name="311" href="#311">311</a>         Assert.assertEquals(<span class="jxr_string">"toString 1b"</span>, route1a.toString(), route1b.toString());
<a class="jxr_linenumber" name="312" href="#312">312</a>         Assert.assertEquals(<span class="jxr_string">"toString 1c"</span>, route1a.toString(), route1c.toString());
<a class="jxr_linenumber" name="313" href="#313">313</a> 
<a class="jxr_linenumber" name="314" href="#314">314</a>         <em class="jxr_comment">// now create some differing routes</em>
<a class="jxr_linenumber" name="315" href="#315">315</a>         HttpRoute route2a = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="316" href="#316">316</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="317" href="#317">317</a>         HttpRoute route2b = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL42, chain3, false,
<a class="jxr_linenumber" name="318" href="#318">318</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="319" href="#319">319</a>         HttpRoute route2c = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, chain3, false,
<a class="jxr_linenumber" name="320" href="#320">320</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="321" href="#321">321</a>         HttpRoute route2d = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, chain3, false,
<a class="jxr_linenumber" name="322" href="#322">322</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="323" href="#323">323</a>         HttpRoute route2e = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, (HttpHost[]) <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="324" href="#324">324</a>                                           false,
<a class="jxr_linenumber" name="325" href="#325">325</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="326" href="#326">326</a>         HttpRoute route2f = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain0, false,
<a class="jxr_linenumber" name="327" href="#327">327</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="328" href="#328">328</a>         HttpRoute route2g = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain1, false,
<a class="jxr_linenumber" name="329" href="#329">329</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="330" href="#330">330</a>         HttpRoute route2h = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain4, false,
<a class="jxr_linenumber" name="331" href="#331">331</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="332" href="#332">332</a>         HttpRoute route2i = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="333" href="#333">333</a>                                           TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="334" href="#334">334</a>         HttpRoute route2j = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="335" href="#335">335</a>                                         TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="336" href="#336">336</a>         HttpRoute route2k = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL41, chain3, false,
<a class="jxr_linenumber" name="337" href="#337">337</a>                                           TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="338" href="#338">338</a> 
<a class="jxr_linenumber" name="339" href="#339">339</a>         <em class="jxr_comment">// check a special case first: 2f should be the same as 2e</em>
<a class="jxr_linenumber" name="340" href="#340">340</a>         Assert.assertEquals(<span class="jxr_string">"2e 2f"</span>, route2e, route2f);
<a class="jxr_linenumber" name="341" href="#341">341</a>         Assert.assertEquals(<span class="jxr_string">"hashcode 2e 2f"</span>, route2e.hashCode(), route2f.hashCode());
<a class="jxr_linenumber" name="342" href="#342">342</a>         Assert.assertEquals(<span class="jxr_string">"toString 2e 2f"</span>, route2e.toString(), route2f.toString());
<a class="jxr_linenumber" name="343" href="#343">343</a> 
<a class="jxr_linenumber" name="344" href="#344">344</a>         Assert.assertFalse(<span class="jxr_string">"1a 2a"</span>, route1a.equals(route2a));
<a class="jxr_linenumber" name="345" href="#345">345</a>         Assert.assertFalse(<span class="jxr_string">"1a 2b"</span>, route1a.equals(route2b));
<a class="jxr_linenumber" name="346" href="#346">346</a>         Assert.assertFalse(<span class="jxr_string">"1a 2c"</span>, route1a.equals(route2c));
<a class="jxr_linenumber" name="347" href="#347">347</a>         Assert.assertFalse(<span class="jxr_string">"1a 2d"</span>, route1a.equals(route2d));
<a class="jxr_linenumber" name="348" href="#348">348</a>         Assert.assertFalse(<span class="jxr_string">"1a 2e"</span>, route1a.equals(route2e));
<a class="jxr_linenumber" name="349" href="#349">349</a>         Assert.assertFalse(<span class="jxr_string">"1a 2f"</span>, route1a.equals(route2f));
<a class="jxr_linenumber" name="350" href="#350">350</a>         Assert.assertFalse(<span class="jxr_string">"1a 2g"</span>, route1a.equals(route2g));
<a class="jxr_linenumber" name="351" href="#351">351</a>         Assert.assertFalse(<span class="jxr_string">"1a 2h"</span>, route1a.equals(route2h));
<a class="jxr_linenumber" name="352" href="#352">352</a>         Assert.assertFalse(<span class="jxr_string">"1a 2i"</span>, route1a.equals(route2i));
<a class="jxr_linenumber" name="353" href="#353">353</a>         Assert.assertFalse(<span class="jxr_string">"1a 2j"</span>, route1a.equals(route2j));
<a class="jxr_linenumber" name="354" href="#354">354</a>         Assert.assertFalse(<span class="jxr_string">"1a 2k"</span>, route1a.equals(route2k));
<a class="jxr_linenumber" name="355" href="#355">355</a> 
<a class="jxr_linenumber" name="356" href="#356">356</a>         <em class="jxr_comment">// repeat the checks in the other direction</em>
<a class="jxr_linenumber" name="357" href="#357">357</a>         <em class="jxr_comment">// there could be problems with detecting null attributes</em>
<a class="jxr_linenumber" name="358" href="#358">358</a> 
<a class="jxr_linenumber" name="359" href="#359">359</a>         Assert.assertFalse(<span class="jxr_string">"2a 1a"</span>, route2a.equals(route1a));
<a class="jxr_linenumber" name="360" href="#360">360</a>         Assert.assertFalse(<span class="jxr_string">"2b 1a"</span>, route2b.equals(route1a));
<a class="jxr_linenumber" name="361" href="#361">361</a>         Assert.assertFalse(<span class="jxr_string">"2c 1a"</span>, route2c.equals(route1a));
<a class="jxr_linenumber" name="362" href="#362">362</a>         Assert.assertFalse(<span class="jxr_string">"2d 1a"</span>, route2d.equals(route1a));
<a class="jxr_linenumber" name="363" href="#363">363</a>         Assert.assertFalse(<span class="jxr_string">"2e 1a"</span>, route2e.equals(route1a));
<a class="jxr_linenumber" name="364" href="#364">364</a>         Assert.assertFalse(<span class="jxr_string">"2f 1a"</span>, route2f.equals(route1a));
<a class="jxr_linenumber" name="365" href="#365">365</a>         Assert.assertFalse(<span class="jxr_string">"2g 1a"</span>, route2g.equals(route1a));
<a class="jxr_linenumber" name="366" href="#366">366</a>         Assert.assertFalse(<span class="jxr_string">"2h 1a"</span>, route2h.equals(route1a));
<a class="jxr_linenumber" name="367" href="#367">367</a>         Assert.assertFalse(<span class="jxr_string">"2i 1a"</span>, route2i.equals(route1a));
<a class="jxr_linenumber" name="368" href="#368">368</a>         Assert.assertFalse(<span class="jxr_string">"2j 1a"</span>, route2j.equals(route1a));
<a class="jxr_linenumber" name="369" href="#369">369</a>         Assert.assertFalse(<span class="jxr_string">"2k 1a"</span>, route2k.equals(route1a));
<a class="jxr_linenumber" name="370" href="#370">370</a> 
<a class="jxr_linenumber" name="371" href="#371">371</a>         <em class="jxr_comment">// don't check hashCode, it's not guaranteed to be different</em>
<a class="jxr_linenumber" name="372" href="#372">372</a> 
<a class="jxr_linenumber" name="373" href="#373">373</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2a"</span>,
<a class="jxr_linenumber" name="374" href="#374">374</a>                     route1a.toString().equals(route2a.toString()));
<a class="jxr_linenumber" name="375" href="#375">375</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2b"</span>,
<a class="jxr_linenumber" name="376" href="#376">376</a>                     route1a.toString().equals(route2b.toString()));
<a class="jxr_linenumber" name="377" href="#377">377</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2c"</span>,
<a class="jxr_linenumber" name="378" href="#378">378</a>                     route1a.toString().equals(route2c.toString()));
<a class="jxr_linenumber" name="379" href="#379">379</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2d"</span>,
<a class="jxr_linenumber" name="380" href="#380">380</a>                     route1a.toString().equals(route2d.toString()));
<a class="jxr_linenumber" name="381" href="#381">381</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2e"</span>,
<a class="jxr_linenumber" name="382" href="#382">382</a>                     route1a.toString().equals(route2e.toString()));
<a class="jxr_linenumber" name="383" href="#383">383</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2f"</span>,
<a class="jxr_linenumber" name="384" href="#384">384</a>                     route1a.toString().equals(route2f.toString()));
<a class="jxr_linenumber" name="385" href="#385">385</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2g"</span>,
<a class="jxr_linenumber" name="386" href="#386">386</a>                     route1a.toString().equals(route2g.toString()));
<a class="jxr_linenumber" name="387" href="#387">387</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2h"</span>,
<a class="jxr_linenumber" name="388" href="#388">388</a>                     route1a.toString().equals(route2h.toString()));
<a class="jxr_linenumber" name="389" href="#389">389</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2i"</span>,
<a class="jxr_linenumber" name="390" href="#390">390</a>                     route1a.toString().equals(route2i.toString()));
<a class="jxr_linenumber" name="391" href="#391">391</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2j"</span>,
<a class="jxr_linenumber" name="392" href="#392">392</a>                     route1a.toString().equals(route2j.toString()));
<a class="jxr_linenumber" name="393" href="#393">393</a>         Assert.assertFalse(<span class="jxr_string">"toString 1a 2k"</span>,
<a class="jxr_linenumber" name="394" href="#394">394</a>                     route1a.toString().equals(route2k.toString()));
<a class="jxr_linenumber" name="395" href="#395">395</a> 
<a class="jxr_linenumber" name="396" href="#396">396</a>         <em class="jxr_comment">// now check that all of the routes are different from eachother</em>
<a class="jxr_linenumber" name="397" href="#397">397</a>         <em class="jxr_comment">// except for those that aren't :-)</em>
<a class="jxr_linenumber" name="398" href="#398">398</a>         Set&lt;HttpRoute&gt; routes = <strong class="jxr_keyword">new</strong> HashSet&lt;HttpRoute&gt;();
<a class="jxr_linenumber" name="399" href="#399">399</a>         routes.add(route1a);
<a class="jxr_linenumber" name="400" href="#400">400</a>         routes.add(route2a);
<a class="jxr_linenumber" name="401" href="#401">401</a>         routes.add(route2b);
<a class="jxr_linenumber" name="402" href="#402">402</a>         routes.add(route2c);
<a class="jxr_linenumber" name="403" href="#403">403</a>         routes.add(route2d);
<a class="jxr_linenumber" name="404" href="#404">404</a>         routes.add(route2e);
<a class="jxr_linenumber" name="405" href="#405">405</a>         <em class="jxr_comment">//routes.add(route2f); // 2f is the same as 2e</em>
<a class="jxr_linenumber" name="406" href="#406">406</a>         routes.add(route2g);
<a class="jxr_linenumber" name="407" href="#407">407</a>         routes.add(route2h);
<a class="jxr_linenumber" name="408" href="#408">408</a>         routes.add(route2i);
<a class="jxr_linenumber" name="409" href="#409">409</a>         routes.add(route2j);
<a class="jxr_linenumber" name="410" href="#410">410</a>         routes.add(route2k);
<a class="jxr_linenumber" name="411" href="#411">411</a>         Assert.assertEquals(<span class="jxr_string">"some routes are equal"</span>, 11, routes.size());
<a class="jxr_linenumber" name="412" href="#412">412</a> 
<a class="jxr_linenumber" name="413" href="#413">413</a>         <em class="jxr_comment">// and a run of cloning over the set</em>
<a class="jxr_linenumber" name="414" href="#414">414</a>         Iterator&lt;HttpRoute&gt; iter = routes.iterator();
<a class="jxr_linenumber" name="415" href="#415">415</a>         <strong class="jxr_keyword">while</strong> (iter.hasNext()) {
<a class="jxr_linenumber" name="416" href="#416">416</a>             HttpRoute origin = iter.next();
<a class="jxr_linenumber" name="417" href="#417">417</a>             HttpRoute cloned = (HttpRoute) origin.clone();
<a class="jxr_linenumber" name="418" href="#418">418</a>             Assert.assertEquals(<span class="jxr_string">"clone of "</span> + origin, origin, cloned);
<a class="jxr_linenumber" name="419" href="#419">419</a>             Assert.assertTrue(<span class="jxr_string">"clone of "</span> + origin, routes.contains(cloned));
<a class="jxr_linenumber" name="420" href="#420">420</a>         }
<a class="jxr_linenumber" name="421" href="#421">421</a> 
<a class="jxr_linenumber" name="422" href="#422">422</a>         <em class="jxr_comment">// and don't forget toString</em>
<a class="jxr_linenumber" name="423" href="#423">423</a>         Set&lt;String&gt; routestrings = <strong class="jxr_keyword">new</strong> HashSet&lt;String&gt;();
<a class="jxr_linenumber" name="424" href="#424">424</a>         routestrings.add(route1a.toString());
<a class="jxr_linenumber" name="425" href="#425">425</a>         routestrings.add(route2a.toString());
<a class="jxr_linenumber" name="426" href="#426">426</a>         routestrings.add(route2b.toString());
<a class="jxr_linenumber" name="427" href="#427">427</a>         routestrings.add(route2c.toString());
<a class="jxr_linenumber" name="428" href="#428">428</a>         routestrings.add(route2d.toString());
<a class="jxr_linenumber" name="429" href="#429">429</a>         routestrings.add(route2e.toString());
<a class="jxr_linenumber" name="430" href="#430">430</a>         <em class="jxr_comment">//routestrings.add(route2f.toString()); // 2f is the same as 2e</em>
<a class="jxr_linenumber" name="431" href="#431">431</a>         routestrings.add(route2g.toString());
<a class="jxr_linenumber" name="432" href="#432">432</a>         routestrings.add(route2h.toString());
<a class="jxr_linenumber" name="433" href="#433">433</a>         routestrings.add(route2i.toString());
<a class="jxr_linenumber" name="434" href="#434">434</a>         routestrings.add(route2j.toString());
<a class="jxr_linenumber" name="435" href="#435">435</a>         routestrings.add(route2k.toString());
<a class="jxr_linenumber" name="436" href="#436">436</a>         Assert.assertEquals(<span class="jxr_string">"some route.toString() are equal"</span>,
<a class="jxr_linenumber" name="437" href="#437">437</a>                      11, routestrings.size());
<a class="jxr_linenumber" name="438" href="#438">438</a> 
<a class="jxr_linenumber" name="439" href="#439">439</a>         <em class="jxr_comment">// finally, compare with nonsense</em>
<a class="jxr_linenumber" name="440" href="#440">440</a>         Assert.assertFalse(<span class="jxr_string">"route equals null"</span>, route1a.equals(<strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="441" href="#441">441</a>         Assert.assertFalse(<span class="jxr_string">"route equals string"</span>, route1a.equals(<span class="jxr_string">"route1a"</span>));
<a class="jxr_linenumber" name="442" href="#442">442</a>     }
<a class="jxr_linenumber" name="443" href="#443">443</a> 
<a class="jxr_linenumber" name="444" href="#444">444</a>     @Test
<a class="jxr_linenumber" name="445" href="#445">445</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testHopping() {
<a class="jxr_linenumber" name="446" href="#446">446</a>         <em class="jxr_comment">// test getHopCount() and getHopTarget() with different proxy chains</em>
<a class="jxr_linenumber" name="447" href="#447">447</a>         HttpHost[] proxies = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="448" href="#448">448</a>         HttpRoute  route   = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, proxies, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="449" href="#449">449</a>                                            TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="450" href="#450">450</a>         Assert.assertEquals(<span class="jxr_string">"A: hop count"</span>, 1, route.getHopCount());
<a class="jxr_linenumber" name="451" href="#451">451</a>         Assert.assertEquals(<span class="jxr_string">"A: hop 0"</span>, TARGET1, route.getHopTarget(0));
<a class="jxr_linenumber" name="452" href="#452">452</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="453" href="#453">453</a>             HttpHost beyond = route.getHopTarget(1);
<a class="jxr_linenumber" name="454" href="#454">454</a>             Assert.fail(<span class="jxr_string">"A: hop 1 is "</span> + beyond);
<a class="jxr_linenumber" name="455" href="#455">455</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="456" href="#456">456</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="457" href="#457">457</a>         }
<a class="jxr_linenumber" name="458" href="#458">458</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="459" href="#459">459</a>             HttpHost before = route.getHopTarget(-1);
<a class="jxr_linenumber" name="460" href="#460">460</a>             Assert.fail(<span class="jxr_string">"A: hop -1 is "</span> + before);
<a class="jxr_linenumber" name="461" href="#461">461</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="462" href="#462">462</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="463" href="#463">463</a>         }
<a class="jxr_linenumber" name="464" href="#464">464</a> 
<a class="jxr_linenumber" name="465" href="#465">465</a> 
<a class="jxr_linenumber" name="466" href="#466">466</a>         proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY3 };
<a class="jxr_linenumber" name="467" href="#467">467</a>         route   = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL62, proxies, false,
<a class="jxr_linenumber" name="468" href="#468">468</a>                                 TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="469" href="#469">469</a>         Assert.assertEquals(<span class="jxr_string">"B: hop count"</span>, 2, route.getHopCount());
<a class="jxr_linenumber" name="470" href="#470">470</a>         Assert.assertEquals(<span class="jxr_string">"B: hop 0"</span>, PROXY3, route.getHopTarget(0));
<a class="jxr_linenumber" name="471" href="#471">471</a>         Assert.assertEquals(<span class="jxr_string">"B: hop 1"</span>, TARGET1, route.getHopTarget(1));
<a class="jxr_linenumber" name="472" href="#472">472</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="473" href="#473">473</a>             HttpHost beyond = route.getHopTarget(2);
<a class="jxr_linenumber" name="474" href="#474">474</a>             Assert.fail(<span class="jxr_string">"B: hop 2 is "</span> + beyond);
<a class="jxr_linenumber" name="475" href="#475">475</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="476" href="#476">476</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="477" href="#477">477</a>         }
<a class="jxr_linenumber" name="478" href="#478">478</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="479" href="#479">479</a>             HttpHost before = route.getHopTarget(-2);
<a class="jxr_linenumber" name="480" href="#480">480</a>             Assert.fail(<span class="jxr_string">"B: hop -2 is "</span> + before);
<a class="jxr_linenumber" name="481" href="#481">481</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="482" href="#482">482</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="483" href="#483">483</a>         }
<a class="jxr_linenumber" name="484" href="#484">484</a> 
<a class="jxr_linenumber" name="485" href="#485">485</a> 
<a class="jxr_linenumber" name="486" href="#486">486</a>         proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY3, PROXY1, PROXY2 };
<a class="jxr_linenumber" name="487" href="#487">487</a>         route   = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL42, proxies, false,
<a class="jxr_linenumber" name="488" href="#488">488</a>                                 TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="489" href="#489">489</a>         Assert.assertEquals(<span class="jxr_string">"C: hop count"</span>, 4, route.getHopCount());
<a class="jxr_linenumber" name="490" href="#490">490</a>         Assert.assertEquals(<span class="jxr_string">"C: hop 0"</span>, PROXY3 , route.getHopTarget(0));
<a class="jxr_linenumber" name="491" href="#491">491</a>         Assert.assertEquals(<span class="jxr_string">"C: hop 1"</span>, PROXY1 , route.getHopTarget(1));
<a class="jxr_linenumber" name="492" href="#492">492</a>         Assert.assertEquals(<span class="jxr_string">"C: hop 2"</span>, PROXY2 , route.getHopTarget(2));
<a class="jxr_linenumber" name="493" href="#493">493</a>         Assert.assertEquals(<span class="jxr_string">"C: hop 3"</span>, TARGET1, route.getHopTarget(3));
<a class="jxr_linenumber" name="494" href="#494">494</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="495" href="#495">495</a>             HttpHost beyond = route.getHopTarget(4);
<a class="jxr_linenumber" name="496" href="#496">496</a>             Assert.fail(<span class="jxr_string">"C: hop 4 is "</span> + beyond);
<a class="jxr_linenumber" name="497" href="#497">497</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="498" href="#498">498</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="499" href="#499">499</a>         }
<a class="jxr_linenumber" name="500" href="#500">500</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="501" href="#501">501</a>             HttpHost before = route.getHopTarget(Integer.MIN_VALUE);
<a class="jxr_linenumber" name="502" href="#502">502</a>             Assert.fail(<span class="jxr_string">"C: hop -&lt;min&gt; is "</span> + before);
<a class="jxr_linenumber" name="503" href="#503">503</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="504" href="#504">504</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="505" href="#505">505</a>         }
<a class="jxr_linenumber" name="506" href="#506">506</a>     }
<a class="jxr_linenumber" name="507" href="#507">507</a> 
<a class="jxr_linenumber" name="508" href="#508">508</a>     @Test
<a class="jxr_linenumber" name="509" href="#509">509</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstr1() {
<a class="jxr_linenumber" name="510" href="#510">510</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2);
<a class="jxr_linenumber" name="511" href="#511">511</a>         HttpRoute should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="512" href="#512">512</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, (HttpHost[]) <strong class="jxr_keyword">null</strong>, false,
<a class="jxr_linenumber" name="513" href="#513">513</a>              TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="514" href="#514">514</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route"</span>, route, should);
<a class="jxr_linenumber" name="515" href="#515">515</a>     }
<a class="jxr_linenumber" name="516" href="#516">516</a> 
<a class="jxr_linenumber" name="517" href="#517">517</a>     @Test
<a class="jxr_linenumber" name="518" href="#518">518</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstr3() {
<a class="jxr_linenumber" name="519" href="#519">519</a>         <em class="jxr_comment">// test convenience constructor with 3 arguments</em>
<a class="jxr_linenumber" name="520" href="#520">520</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL61, false);
<a class="jxr_linenumber" name="521" href="#521">521</a>         HttpRoute should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="522" href="#522">522</a>             (TARGET2, LOCAL61, (HttpHost[]) <strong class="jxr_keyword">null</strong>, false,
<a class="jxr_linenumber" name="523" href="#523">523</a>              TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="524" href="#524">524</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 3/insecure"</span>, route, should);
<a class="jxr_linenumber" name="525" href="#525">525</a> 
<a class="jxr_linenumber" name="526" href="#526">526</a>         route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="527" href="#527">527</a>         should = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, <strong class="jxr_keyword">null</strong>, (HttpHost[]) <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="528" href="#528">528</a>                                TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="529" href="#529">529</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 3/secure"</span>, route, should);
<a class="jxr_linenumber" name="530" href="#530">530</a>     }
<a class="jxr_linenumber" name="531" href="#531">531</a> 
<a class="jxr_linenumber" name="532" href="#532">532</a>     @Test
<a class="jxr_linenumber" name="533" href="#533">533</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstr4() {
<a class="jxr_linenumber" name="534" href="#534">534</a>         <em class="jxr_comment">// test convenience constructor with 4 arguments</em>
<a class="jxr_linenumber" name="535" href="#535">535</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, <strong class="jxr_keyword">null</strong>, PROXY2, false);
<a class="jxr_linenumber" name="536" href="#536">536</a>         HttpRoute should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="537" href="#537">537</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY2 }, false,
<a class="jxr_linenumber" name="538" href="#538">538</a>              TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="539" href="#539">539</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 4/insecure"</span>, route, should);
<a class="jxr_linenumber" name="540" href="#540">540</a> 
<a class="jxr_linenumber" name="541" href="#541">541</a>         route = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET2, LOCAL42, PROXY1, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="542" href="#542">542</a>         should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="543" href="#543">543</a>             (TARGET2, LOCAL42, <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY1 }, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="544" href="#544">544</a>              TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="545" href="#545">545</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 4/secure"</span>, route, should);
<a class="jxr_linenumber" name="546" href="#546">546</a> 
<a class="jxr_linenumber" name="547" href="#547">547</a>         <em class="jxr_comment">// this constructor REQUIRES a proxy to be specified</em>
<a class="jxr_linenumber" name="548" href="#548">548</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="549" href="#549">549</a>             <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, LOCAL61, <strong class="jxr_keyword">null</strong>, false);
<a class="jxr_linenumber" name="550" href="#550">550</a>             Assert.fail(<span class="jxr_string">"missing proxy not detected"</span>);
<a class="jxr_linenumber" name="551" href="#551">551</a>         } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException iax) {
<a class="jxr_linenumber" name="552" href="#552">552</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="553" href="#553">553</a>         }
<a class="jxr_linenumber" name="554" href="#554">554</a>     }
<a class="jxr_linenumber" name="555" href="#555">555</a> 
<a class="jxr_linenumber" name="556" href="#556">556</a>     @Test
<a class="jxr_linenumber" name="557" href="#557">557</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCstr6() {
<a class="jxr_linenumber" name="558" href="#558">558</a>         <em class="jxr_comment">// test convenience constructor with 6 arguments</em>
<a class="jxr_linenumber" name="559" href="#559">559</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="560" href="#560">560</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, PROXY2, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="561" href="#561">561</a>              TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="562" href="#562">562</a>         HttpRoute should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="563" href="#563">563</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY2 }, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="564" href="#564">564</a>              TunnelType.TUNNELLED, LayerType.PLAIN);
<a class="jxr_linenumber" name="565" href="#565">565</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 6/proxied"</span>, route, should);
<a class="jxr_linenumber" name="566" href="#566">566</a> 
<a class="jxr_linenumber" name="567" href="#567">567</a>         route = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="568" href="#568">568</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, (HttpHost) <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="569" href="#569">569</a>              TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="570" href="#570">570</a>         should = <strong class="jxr_keyword">new</strong> HttpRoute
<a class="jxr_linenumber" name="571" href="#571">571</a>             (TARGET2, <strong class="jxr_keyword">null</strong>, (HttpHost[]) <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="572" href="#572">572</a>              TunnelType.PLAIN, LayerType.LAYERED);
<a class="jxr_linenumber" name="573" href="#573">573</a>         Assert.assertEquals(<span class="jxr_string">"bad convenience route 6/direct"</span>, route, should);
<a class="jxr_linenumber" name="574" href="#574">574</a> 
<a class="jxr_linenumber" name="575" href="#575">575</a>         <em class="jxr_comment">// handling of null vs. empty chain is checked in the equals tests</em>
<a class="jxr_linenumber" name="576" href="#576">576</a>     }
<a class="jxr_linenumber" name="577" href="#577">577</a> 
<a class="jxr_linenumber" name="578" href="#578">578</a>     @Test
<a class="jxr_linenumber" name="579" href="#579">579</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testImmutable() <strong class="jxr_keyword">throws</strong> CloneNotSupportedException {
<a class="jxr_linenumber" name="580" href="#580">580</a> 
<a class="jxr_linenumber" name="581" href="#581">581</a>         HttpHost[] proxies = <strong class="jxr_keyword">new</strong> HttpHost[]{ PROXY1, PROXY2, PROXY3 };
<a class="jxr_linenumber" name="582" href="#582">582</a>         HttpRoute route1 = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>, proxies, false,
<a class="jxr_linenumber" name="583" href="#583">583</a>                                          TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="584" href="#584">584</a>         HttpRoute route2 = (HttpRoute) route1.clone();
<a class="jxr_linenumber" name="585" href="#585">585</a>         HttpRoute route3 = <strong class="jxr_keyword">new</strong> HttpRoute(TARGET1, <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="586" href="#586">586</a>                                          proxies.clone(), false,
<a class="jxr_linenumber" name="587" href="#587">587</a>                                          TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="588" href="#588">588</a> 
<a class="jxr_linenumber" name="589" href="#589">589</a>         <em class="jxr_comment">// modify the array that was passed to the constructor of route1</em>
<a class="jxr_linenumber" name="590" href="#590">590</a>         proxies[1] = PROXY3;
<a class="jxr_linenumber" name="591" href="#591">591</a>         proxies[2] = PROXY2;
<a class="jxr_linenumber" name="592" href="#592">592</a> 
<a class="jxr_linenumber" name="593" href="#593">593</a>         Assert.assertEquals(<span class="jxr_string">"route differs from clone"</span>, route2, route1);
<a class="jxr_linenumber" name="594" href="#594">594</a>         Assert.assertEquals(<span class="jxr_string">"route was modified"</span>, route3, route1);
<a class="jxr_linenumber" name="595" href="#595">595</a>     }
<a class="jxr_linenumber" name="596" href="#596">596</a> 
<a class="jxr_linenumber" name="597" href="#597">597</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

